package util.concurrent;

import org.junit.jupiter.api.Test;
import util.testing.AbstractTest;

public class Counter_Test
        extends AbstractTest {
    
    @Test
    public void testBasicMechanism() throws Exception {
        Counter counter = new Counter();
        info("Initial value: " + counter.get());
//        Assert.isEqual(counter.get(), 0);
        
        counter.incrementAndGet();
        info("After incrementing: " + counter.get());
//        Assert.isEqual(counter.get(), 1);
    }
    
    @Test
    public void testOverflow() throws Exception {
        Counter counter = new Counter();
        info("Initial value: " + counter.get());
//        Assert.isEqual(counter.get(), 0);
        
        counter.set(Long.MAX_VALUE);
        info("Before overflow: " + counter.get());
//        Assert.isEqual(counter.get(), Long.MAX_VALUE);
        
        counter.incrementAndGet();
        info("After overflow: " + counter.get());
//        Assert.isEqual(counter.get(), 0);
    }
}
